"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils = require("./utils");
var Row = /** @class */ (function () {
    function Row() {
    }
    return Row;
}());
var Collection = /** @class */ (function () {
    function Collection(collectionId, collectionViewId, rawData, client) {
        var _this = this;
        this.collectionId = collectionId;
        this.collectionViewId = collectionViewId;
        this.rawData = rawData;
        this.client = client;
        this._schema = rawData.recordMap.collection[collectionId].value.schema;
        this.total = rawData.result.total;
        this.value = rawData.recordMap.collection[collectionId].value;
        this.props = Object.entries(this._schema).map(function (item) {
            var key = item[0], v = item[1];
            return v.name;
        });
        this.props.push('_raw');
        this.propsKeyMap = {};
        Object.entries(this._schema).map(function (item) {
            var key = item[0], v = item[1];
            _this.propsKeyMap[v.name] = __assign({ key: key }, v);
        });
        // cache
        this.client.blockStore = __assign(__assign({}, this.client.blockStore), rawData.recordMap.block);
        this.completed = false;
        // isFetchAll 默认打开，如果表格记录超过 980 条，会自动获取后面的数据。
        if (this.client.isFetchAll) {
            (function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.total > 980)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.fetchMore()];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2:
                            this.completed = true;
                            return [2 /*return*/, this];
                    }
                });
            }); })();
        }
        else {
            // isFetchAll 关闭的状态，表格记录超过 980 条， 控制台给出警告。后续的调用可能会有问题。
            if (this.total > 980) {
                console.warn("This table has more than 980 rows, but you set isFetchAll off. you can call collection.fetchMore() to get rest records");
            }
        }
    }
    Collection.prototype.updateSchemaProps = function () {
        var _this = this;
        this.props = Object.entries(this._schema).map(function (item) {
            var key = item[0], v = item[1];
            return v.name;
        });
        Object.entries(this._schema).forEach(function (item) {
            var key = item[0], v = item[1];
            _this.propsKeyMap[v.name] = __assign({ key: key }, v);
        });
    };
    Collection.prototype.fetchMore = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data, blockIds, blocksDataList;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.client.queryCollection(this.collectionId, this.collectionViewId, this.total)];
                    case 1:
                        data = _a.sent();
                        blockIds = data.result.blockIds.slice(980, this.total);
                        return [4 /*yield*/, this.client.getRecordValues(blockIds, [])];
                    case 2:
                        blocksDataList = _a.sent();
                        blocksDataList.forEach(function (item) {
                            _this.client.blockStore[item.value.id] = item;
                        });
                        // update blockIds
                        this.rawData.result = data.result;
                        return [2 /*return*/];
                }
            });
        });
    };
    Collection.prototype.addRow = function (data) {
        var _this = this;
        var newId = this.client.genId();
        var args = {};
        var updateData;
        if (data) {
            Object.entries(data).map(function (item) {
                var prop = item[0], value = item[1];
                var notionData = _this.js2notion(prop, value, _this.propsKeyMap);
                var _a = _this.propsKeyMap[prop], key = _a.key, type = _a.type;
                args[key] = notionData;
            });
            updateData = { "id": newId, "table": "block", "path": ["properties"], "command": "set", "args": args };
        }
        var postData = {
            "operations": [
                {
                    args: { type: "page", id: newId, version: 1 },
                    command: "set",
                    id: newId,
                    path: [],
                    table: "block"
                },
                {
                    args: { parent_id: this.collectionId, parent_table: "collection", alive: true },
                    command: "update",
                    id: newId,
                    path: [],
                    table: "block"
                },
                {
                    args: {
                        // created_by: "c8e68ca2-a84d-4792-a6d6-1e7716982001",
                        created_time: (new Date()).getTime(),
                        // last_edited_by: "c8e68ca2-a84d-4792-a6d6-1e7716982001",
                        last_edited_time: (new Date()).getTime()
                    },
                    command: "update",
                    id: newId,
                    path: [],
                    table: "block"
                } // [fixme] set create/edit time
            ]
        };
        if (updateData) {
            postData.operations.push(updateData);
        }
        this.client.submitTransaction(postData);
        this.client.blockStore[newId] = {
            value: {
                id: newId,
                parent_id: this.collectionId,
                parent_table: "collection",
                alive: true,
                created_time: (new Date()).getTime(),
                last_edited_time: (new Date()).getTime(),
                properties: args
            }
        };
        return this.makeRow(newId, this._schema);
    };
    Collection.prototype.checkOrCreateSelectOptions = function (prop, value, type) {
        var _this = this;
        // init options fix
        if (!this.schema[prop].options) {
            this.schema[prop].options = [];
        }
        if (type === "select") {
            if (!this.schema[prop].options.find(function (o) { return o.value === value; })) {
                // if select value is not exists,create it & update schema
                this.schema[prop].options.push({
                    id: this.client.genId(),
                    value: value
                });
                this.updateSchema();
            }
        }
        else if (type === "multi_select") {
            var needUpdateSchema_1 = false;
            value.map(function (v) {
                if (!_this.schema[prop].options.find(function (o) { return o.value === v; })) {
                    // if select value is not exists,create it & update schema
                    needUpdateSchema_1 = true;
                    _this.schema[prop].options.push({
                        id: _this.client.genId(),
                        value: v
                    });
                }
            });
            if (needUpdateSchema_1) {
                this.updateSchema();
            }
        }
    };
    Collection.prototype.js2notion = function (prop, value, propsKeyMap) {
        var newV;
        // fuck babel
        switch (propsKeyMap[prop].type) {
            case 'title':
            case 'text':
            case 'url':
            case 'email':
            case 'phone_number':
            case 'number':
                newV = [[value + ""]]; // 强制转化成字符串，否则后续修改表格数据可能会造成客户端崩溃。
                break;
            case 'checkbox':
                newV = value ? [['Yes']] : [['No']];
                break;
            case 'file':
                if (value.length === 1 && value[0]) {
                    newV = [[value[0], [["a", value[0]]]]];
                }
                else if (value.length === 0) {
                    newV = [];
                }
                else {
                    newV = value.reduce(function (a, b, index) {
                        if (index === 1) {
                            return [[a, [["a", a]]]].concat([
                                [","],
                                [b, [["a", b]]]
                            ]);
                        }
                        else {
                            return a.concat([
                                [","],
                                [b, [["a", b]]]
                            ]);
                        }
                    });
                }
                break;
            case 'select':
                this.checkOrCreateSelectOptions(prop, value, 'select');
                newV = [[value + ""]];
                break;
            case 'multi_select':
                this.checkOrCreateSelectOptions(prop, value, 'multi_select');
                if (value instanceof Array) {
                    value.map(function (v) { });
                    newV = [[value.join(',')]];
                }
                break;
            case 'person':
                if (value instanceof Array) {
                    if (value.length === 1) {
                        newV = [["‣", [["u", value[0]]]]];
                    }
                    else if (value.length === 0) {
                        newV = [];
                    }
                    else {
                        newV = value.reduce(function (a, b, index) {
                            if (index === 1) {
                                return [["‣", [["u", a]]]].concat([
                                    [","],
                                    ["‣", [["u", b]]]
                                ]);
                            }
                            else {
                                return a.concat([
                                    [","],
                                    ["‣", [["u", b]]]
                                ]);
                            }
                        });
                    }
                }
                else {
                    throw Error();
                }
                break;
            case 'date':
                var type = 'date';
                if (value.includeTime) {
                    type += 'time';
                }
                if (value.endDate) {
                    type += 'range';
                }
                var timeZone = value.timeZone || Intl.DateTimeFormat().resolvedOptions().timeZone;
                var startDate = value.startDate;
                var endDate = value.endDate;
                newV = [["‣", [["d", {
                                    time_zone: timeZone,
                                    type: type,
                                    start_date: startDate ? utils.formatDate(utils.unFixTimeZone(startDate, timeZone)) : undefined,
                                    start_time: startDate && value.includeTime ? utils.formatTime(utils.unFixTimeZone(startDate, timeZone)) : undefined,
                                    end_date: endDate ? utils.formatDate(utils.unFixTimeZone(endDate, timeZone)) : undefined,
                                    end_time: endDate && value.includeTime ? utils.formatTime(utils.unFixTimeZone(endDate, timeZone)) : undefined,
                                }]]]];
                break;
            case 'relation':
                // check value type , should be Row
                if (value instanceof Array) {
                    if (value.length === 1 && value[0] instanceof Row) {
                        newV = [["‣", [["p", value[0].id]]]];
                    }
                    else if (value.length === 0) {
                        newV = [];
                    }
                    else {
                        newV = value.filter(function (v) { return v instanceof Row; }).reduce(function (a, b, index) {
                            if (index === 1) {
                                return [["‣", [["p", a.id]]]].concat([
                                    [","],
                                    ["‣", [["p", b.id]]]
                                ]);
                            }
                            else {
                                return a.concat([
                                    [","],
                                    ["‣", [["p", b.id]]]
                                ]);
                            }
                        });
                    }
                    // fixme check (schema[key].collection_id === value.parent_id && value.parent_table === "collection")
                    // throw Error()
                }
                else {
                    throw Error();
                }
                break;
            default:
                newV = [[value + ""]];
        }
        return newV;
    };
    Collection.prototype.notion2js = function (rawValue, type, collection_id) {
        var _this = this;
        var res;
        if (rawValue) {
            switch (type) {
                case 'title':
                case 'url':
                case 'email':
                case 'phone_number':
                case 'select':
                case 'number':
                    res = rawValue[0][0];
                    break;
                case 'text':
                    res = rawValue[0][0];
                    if (res === "‣") {
                        res = rawValue[0][1][0][1];
                    }
                    break;
                case 'checkbox':
                    res = Boolean(rawValue[0][0] === 'Yes');
                    break;
                case 'date': {
                    var date = rawValue[0][1][0][1];
                    res = {
                        startDate: date.start_date ? utils.fixTimeZone(date.start_date + " " + (date.start_time || '00:00'), date.time_zone) : undefined,
                        endDate: date.end_date ? utils.fixTimeZone(date.end_date + " " + (date.end_time || '00:00'), date.time_zone) : undefined,
                        includeTime: date.type.indexOf("time") !== -1,
                        timeZone: date.time_zone
                    };
                    break;
                }
                case 'multi_select':
                    res = rawValue[0][0].split(',');
                    break;
                case 'file':
                    res = rawValue.filter(function (item) {
                        var content = item[1];
                        return Boolean(content);
                    }).map(function (item) {
                        return item[1][0][1];
                    });
                    break;
                case 'person':
                    res = rawValue.filter(function (item) { return item.length > 1; }).map(function (item) { return item[1][0][1]; });
                    break;
                case 'relation':
                    res = rawValue.filter(function (item) { return item.length > 1; }).map(function (item) {
                        var _schema = _this.client.collectionSchemaStore[collection_id];
                        var _blockId = item[1][0][1];
                        if (_schema) {
                            return _this.makeRow(_blockId, _schema);
                        }
                        else {
                            console.log("failed to get relation of " + _blockId);
                            return undefined;
                        }
                    });
                    break;
                case 'rollup':
                    res = rawValue.filter(function (item) { return item.length > 1; }).map(function (item) { return item[1][0]; });
                    break;
                default:
                    res = rawValue;
            }
        }
        return res;
    };
    Collection.prototype.makeRow = function (rowBlockId, schema) {
        var _this = this;
        if (!schema)
            return undefined;
        var rowData = rowBlockId in this.client.blockStore ? this.client.blockStore[rowBlockId].value : undefined;
        var props = Object.entries(schema).map(function (item) {
            var key = item[0], v = item[1];
            return v.name;
        });
        props.push('_raw');
        var propsKeyMap = {};
        Object.entries(schema).map(function (item) {
            var key = item[0], v = item[1];
            propsKeyMap[v.name] = __assign({ key: key }, v);
        });
        if (rowData) {
            var handlers = {
                getPrototypeOf: function (target) {
                    return new Row();
                },
                get: function (target, property) {
                    if (target.hasOwnProperty(property)) {
                        return target[property];
                    }
                    else if (props.indexOf(property) > -1) {
                        if (property === '_raw') {
                            return target;
                        }
                        else {
                            var _a = propsKeyMap[property], key = _a.key, type = _a.type, collection_id = _a.collection_id;
                            var rawValue = target.properties ? target.properties[key] : false;
                            return _this.notion2js(rawValue, type, collection_id);
                        }
                    }
                    else if (property === "delete") {
                        var del = function () {
                            var postData = {
                                "operations": [
                                    {
                                        "id": target.id, "table": "block", "path": [], "command": "update", "args": {
                                            parent_id: _this.collectionId,
                                            parent_table: "collection",
                                            alive: false
                                        }
                                    },
                                    {
                                        "id": target.id, "table": "block", "path": ["last_edited_time"], "command": "set", "args": (new Date()).getTime()
                                    }
                                ]
                            };
                            _this.client.submitTransaction(postData);
                        };
                        return del;
                    }
                    else {
                        return undefined;
                    }
                },
                set: function (target, prop, value, _self) {
                    if (props.indexOf(prop) > -1) {
                        var newV = _this.js2notion(prop, value, propsKeyMap);
                        var _a = propsKeyMap[prop], key = _a.key, type = _a.type;
                        var postData = {
                            "operations": [
                                { "id": target.id, "table": "block", "path": ["properties", key], "command": "set", "args": newV },
                                { "id": target.id, "table": "block", "path": [], "command": "update", "args": { "last_edited_time": (new Date()).getTime() } }
                            ]
                        };
                        _this.client.submitTransaction(postData);
                        _self = Reflect.set(target, prop, value);
                        return _self;
                    }
                    else if (["formatPageIcon", "formatPageCover", "formatPageCoverPosition"].includes(prop)) {
                        // 设置头图和 icon
                        var path = void 0;
                        switch (prop) {
                            case "formatPageIcon":
                                path = ["format", "page_icon"];
                                break;
                            case "formatPageCover":
                                path = ["format", "page_cover"];
                                break;
                            case "formatPageCoverPosition":
                                path = ["format", "page_cover_position"];
                                break;
                        }
                        var postData = {
                            "operations": [
                                { "id": target.id, "table": "block", "path": path, "command": "set", "args": value },
                                { "id": target.id, "table": "block", "path": [], "command": "update", "args": { "last_edited_time": (new Date()).getTime() } }
                            ]
                        };
                        _this.client.submitTransaction(postData);
                        return;
                    }
                }
            };
            var proxy = new Proxy(rowData, handlers);
            // proxy.toString = Function.prototype.toString.bind(rowData)
            return proxy;
        }
    };
    Object.defineProperty(Collection.prototype, "rows", {
        get: function () {
            var _this = this;
            var blockIds = this.rawData.result.blockIds;
            return blockIds.map(function (blockId) { return _this.makeRow(blockId, _this._schema); });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Collection.prototype, "schema", {
        get: function () {
            var _this = this;
            //
            var handlers = {
                get: function (target, prop) {
                    var key = _this.propsKeyMap[prop] && _this.propsKeyMap[prop].key;
                    if (key)
                        return _this._schema[key];
                    return;
                },
            };
            var proxy = new Proxy(this._schema, handlers);
            return proxy;
        },
        enumerable: true,
        configurable: true
    });
    Collection.prototype.updateSchema = function () {
        var postData = {
            "operations": [
                { "id": this.collectionId, "table": "collection", "path": [], "command": "update", "args": { schema: this._schema } },
            ]
        };
        this.updateSchemaProps();
        this.client.submitTransaction(postData);
    };
    return Collection;
}());
exports.Collection = Collection;
